;-================================================================-
; GetOleBitmapFrom - using OleLoadPicture
;                    www.dougiem.fsnet.co.uk/asm
; returns a bmp handle from a resource or filename from the following image formats;
;                                               .gif, .jpg, .bmp, .ico, .emf, .wmf,
;-================================================================-
;
;
;  **NOTE**
;              invoke CoInitialize,0 MUST HAVE BEEN CALLED in application before calling this
;              and CoUnitialise before closing application
;
;
;
; ----------------------------------------------------------------------------------------------
; Usage:
;
;        GetOleBitmapFrom,addr Source,ResNo,addr BITMAP
;
; Source is ptr to file name to load, OR a ptr to resource type (dependant on ResNo).
;
; ResNo: if 0 then Source is a filename. Else it is the Resource number of the resource type.
;
; BITMAP is a ptr to a BITMAP structure which receives info about the loaded bitmap. This can
;        be set to 0 if not required.
;
; RETURNS Ok:    Carry flag clear eax = bitmap handle
;         Error: Carry flag set,  eax = ptr to error code string.
;
; ----------------------------------------------------------------------------------------------
; eg1 from file:
;
; .data
;
; bmpinfo BITMAP <>
; fname   db "Picture.jpg",0
;
; .code
;                                 invoke GetOleBitmapFrom,addr fname,0,addr bmpinfo
;                                 jc error
;                                 .
;                                 .
;                                 .
;                                 .
;                          error: invoke MessageBox,hWin,eax,SADD("Ole Load Error"),MB_OK
; ----------------------------------------------------------------------------------------------

; eg2 from Resource:

; -- in resource file: -------------------------------------------------------------------------
;
;      700   MYDATA    "Picture.jpg"
;
; ----------------------------------------------------------------------------------------------
; .data

; rname   db "MYDATA",0

; .code
;                                 invoke GetOleBitmapFrom,addr rname,700,0
;                                 jc error
;                                 .
;                                 .
;                                 .
;                                 .
;                          error: invoke MessageBox,hWin,eax,SADD("Ole Load Error"),MB_OK
; ----------------------------------------------------------------------------------------------
; ---------------------------------------- the code  -------------------------------------------
; ----------------------------------------------------------------------------------------------





      ;.486                  
      ;.model flat, stdcall 
      ;option casemap :none


       ;include \masm32\include\windows.inc
       ;include \masm32\include\user32.inc
       ;include \masm32\include\kernel32.inc
       ;include \masm32\include\gdi32.inc
       ;include \masm32\include\ole32.inc
       ;include \masm32\include\oleaut32.inc

       ;include \masm32\macros\macros.asm


       GetOleBitmapFrom proto:dword,:dword,:dword


;==============================================================
; E-Z COM Release, by NaN, 2002
;==============================================================
OLE_FREE MACRO pInterface
 .if ( pInterface != NULL )
   ole32 pInterface, 08h      ;; IUnknown_Release
   xor eax, eax
   mov pInterface,eax         ;; Set pInterface = NULL
 .endif                       ;; Return with ole result in eax
ENDM

;==============================================================
; notes on using ole32:
;                use 'offset' not addr
;                pointing to local data; use 'lea eax,localdata'

;==============================================================
; E-Z OLE Calling By Ancev, modified by NaN, 2002
;==============================================================
ole32  macro object, method, rest:VARARG
      LOCAL newlist
      newlist TEXTEQU <>
      
       ifnb <rest>
         for c, <rest>
           newlist CATSTR <c>, <,>,newlist
         ENDM
       newlist SUBSTR newlist, 1, @SizeStr(%newlist)-1
       newlist CATSTR <!<>, newlist, <!>>
       ;;%echo newlist       
       %for  reg, newlist
           push reg
       ENDM     
    endif
       mov eax, [object]
       push eax
       mov eax, [eax]
       call DWORD PTR [eax+method]
endm

  

;-================================================================-
;            .gif, .jpg, .bmp, .ico, .emf, .wmf,
.data

ALIGN 4
sCLSID_IPicture  TEXTEQU <{07BF80980H, 0BF32H, 0101AH,{08BH, 0BBH, 000H, 0AAH, 000H, 030H, 00CH, 0ABH}}>

CLSID_IPicture   GUID sCLSID_IPicture


.const
STREAM_SEEK_SET  equ 0
STREAM_SEEK_CUR  equ 1
STREAM_SEEK_END  equ 2

STATFLAG_DEFAULT equ 0
STATFLAG_NONAME  equ 1
HIMETRIC_INCH    equ 2540

;-================================================================-
ISpStream_Close                        equ   48h
ISpStream_BindToFile                   equ   44h
ISpStream_GetBaseStream                equ   40h
ISpStream_SetBaseStream                equ   3ch           
ISpStream_GetFormat                    equ   38h
ISpStream_Clone                        equ   34h
ISpStream_Stat                         equ   30h
ISpStream_UnlockRegion                 equ   2ch
ISpStream_LockRegion                   equ   28h
ISpStream_Revert                       equ   24h
ISpStream_Commit                       equ   20h
ISpStream_CopyTo                       equ   1ch
ISpStream_SetSize                      equ   18h
ISpStream_Seek                         equ   14h
ISpStream_Write                        equ   10h
ISpStream_Read                         equ   0ch
ISpStream_Release                      equ   08h
ISpStream_Addref                       equ   04h
ISpStream_QueryInterface               equ   00h

;-================================================================-


ISpPicture_QueryInterface              equ   00h
ISpPicture_AddRef                      equ   04h
ISpPicture_Release                     equ   08h
ISpPicture_get_Handle                  equ   0ch
ISpPicture_get_hPal                    equ   10h
ISpPicture_get_Type                    equ   14h
ISpPicture_get_Width                   equ   18h
ISpPicture_get_Height                  equ   1ch
ISpPicture_Render                      equ   20h 
ISpPicture_set_hPal                    equ   24h
ISpPicture_get_CurDC                   equ   28h
ISpPicture_SelectPicture               equ   2ch
ISpPicture_get_KeepOriginalFormat      equ   30h
ISpPicture_put_KeepOriginalFormat      equ   34h
ISpPicture_PictureChanged              equ   38h
ISpPicture_SaveAsFile                  equ   3ch
ISpPicture_get_Attributes              equ   40h

;-================================================================-


.code
ALIGN 4
GetOleBitmapFrom Proc uses ecx edx szSource:dword,nRes:dword,bmpi:dword
local hData:dword
local MemLen :dword
local hGlobal:dword
local pStream:dword
local hRes:dword

local hFile:dword
local br:dword

local pPicture:dword
local hdc:dword
local memdc:dword
local hmWidth:dword
local hmHeight:dword
local dwWidth:dword
local dwHeight:dword
local neghmHeight:dword
local tempBitmap:dword
local old:dword

; first we get the image data, (resource or file) into memory,
; getting the location [hData] and the size [MemLen]

   .if nRes != 0       ;     if resource
       Invoke FindResource,0,nRes,szSource                 ; locate resource offset
       mov ecx,CTXT("Resource not found")
       cmp eax,0
       je error2
       mov hRes,eax
       Invoke SizeofResource,0,eax
       mov MemLen,eax                                      ; save size
       Invoke LoadResource,0,hRes                          ; load resource
       Invoke LockResource,eax                             ; lock resource
       mov hData,eax                                       ; save handle = ptr to data

   .else               ;     if file
       invoke CreateFile,szSource,GENERIC_READ,FILE_SHARE_READ,0,   
                           OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
       mov hFile,eax
       mov ecx,CTXT("File not found")
       cmp eax,INVALID_HANDLE_VALUE
       je error2

       invoke GetFileSize,hFile,0
       mov MemLen,eax                                      ; save size
       invoke GlobalAlloc,GPTR,eax
       mov hData,eax                                       ; save handle = ptr to data

       invoke ReadFile,hFile,hData,MemLen,addr br,0        ; data -> memory
       invoke CloseHandle,hFile
   .endif

; location [hData] and the size [MemLen] is set.
; now we create a stream object and write the data into it
; (the stream memory is released on olefree)

       invoke GlobalAlloc,GMEM_NODISCARD or GMEM_MOVEABLE,0
       mov hGlobal,eax
       invoke CreateStreamOnHGlobal,hGlobal,1,addr pStream

       ole32 pStream,ISpStream_Seek,0,0,STREAM_SEEK_SET,0  
       ole32 pStream,ISpStream_Write,hData,MemLen,0        ; stream <- data

; OleLoadPicture creates pPicture (from our pStream), which is the object we will use

       ole32 pStream,ISpStream_Seek,0,0,STREAM_SEEK_SET,0  ; stream -> IPicture
       invoke OleLoadPicture,pStream,0,0,addr CLSID_IPicture,addr pPicture
       mov ecx,CTXT("Format not supported")
       cmp eax,0
       jne error

; create memory dc to work with
       invoke GetDC,0
       mov hdc,eax
       invoke CreateCompatibleDC,hdc
       mov memdc,eax

; extract width and height using ole32 methods of pPicture
       lea eax,hmWidth
       ole32 pPicture,ISpPicture_get_Width,eax
       invoke GetDeviceCaps,hdc,LOGPIXELSX
       invoke MulDiv,hmWidth,eax,HIMETRIC_INCH
       mov dwWidth,eax

       lea eax,hmHeight
       ole32 pPicture,ISpPicture_get_Height,eax
       invoke GetDeviceCaps,hdc,LOGPIXELSY
       invoke MulDiv,hmHeight,eax,HIMETRIC_INCH
       mov dwHeight,eax
       mov eax,0
       sub eax,hmHeight
       mov neghmHeight,eax

; create our bitmap here
       invoke CreateCompatibleBitmap,hdc,dwWidth,dwHeight
       mov tempBitmap,eax
       invoke SelectObject,memdc,tempBitmap
       mov old,eax

; and render the stream to the bitmap
       ole32 pPicture,ISpPicture_Render,memdc,0,0,dwWidth,dwHeight,0,hmHeight,hmWidth,neghmHeight,0

; tidy
       OLE_FREE pStream
       OLE_FREE pPicture
       cmp nRes,0
       jne @F
       invoke GlobalFree,hData
   @@: invoke ReleaseDC,0,hdc
       invoke SelectObject,memdc,old
       invoke DeleteDC,memdc

; return bmp info to caller if requested
       cmp bmpi,0
       je @F
       invoke GetObject,tempBitmap,sizeof BITMAP,bmpi
   @@: mov eax,tempBitmap
       clc                   ; carry clear eax = handle of bitmap
       ret

error:  push ecx             ; carry set on error and eax is pointer
        OLE_FREE pStream     ; error string
        OLE_FREE pPicture
        pop ecx
error2: mov eax,ecx
        stc
        ret

GetOleBitmapFrom endp
;
;                        end
;
;